/************************************************************************
*	File Name:	btllc.c
*
*	Function:	This is the CP3BT1x Bluetooth LLC driver. All it is used
*               for at the moment is to initialize the Bluetooth LLC
*               hardware.
*
************************************************************************/

#include <string.h>
#include "chipdef.h"
#include "drivers.h"

/******************************************************************************  
    Function: btllc_init

	Description
	-----------
    This function initializes the Bluetooth LLC hardware.

	Arguments
	---------
	None.
*******************************************************************************/

void btllc_init(void)
{
    /* Enable the alternate function of the radio interface pins. */
	gpio_set_alt(BTLLC_MUX_PORT, BTLLC_MUX_MASK, TRUE);

  	/* Enable auxiliary clock 1. This clock is used by the BT LLC. 
  	   Set the auxilary clock 1 prescalar to 1.
	*/
	PRSAC &= 0xf0;
	CRCTRL |= ACE1;

	/* Enable BT LLC and hold it in reset. */
	BT_SYS_CLK_ENABLE = 0xd;
	BT_SEQ_RESET = 0x1; /* Hold Sequencer in Reset */

	/* Clear the Bluetooth data RAM */
	memset((uint8 *)BTLLC_DATA_RAM_ADDR, 0, BTLLC_DATA_RAM_SIZE);

    /* Unmask the BT LLC0 interrupt */
    icu_unmask(BT_LLC0_IRQ);

}
