 ########################################################################
 # This is the CR16BT reset driver.                                     #
 ########################################################################
	.section	.reset, "x"

start::

 #----------------------------------------------------------------------#
 # Initialize the stacks pointers. The constants __STACK_START,         #
 # __ISTACK_START and __STATIC_BASE_START should be defined in the      #
 # linker definition file.                                              #       

    movd    $__STACK_START, (sp)          # Initialize program stack.
    movd    $__ISTACK_START, (r1,r0)         # Initialize interrupt stack.
    lprd    (r1,r0), isp

 #  movd    $__STATIC_BASE_START, (r13) # Initialize static base


 #----------------------------------------------------------------------#
 # Initialize sections according to the linker init table.              #
 # You can choose different functions to initialize a different set     #
 # of sections. The functions available in this library are:            #
 # 1. init_bss()                                                        #
 # 2. init_data()                                                       #
 # 3. init_bss_data()                                                   #
 # 4. init_bss_data_code()                                              #

    bal (ra),  _init_bss_data      

    movd   $__dispatch_table, (r2,r1)           # Initialize intbase.
   spr    cfg, r0	
   orw    $0x100, r0
   lpr    r0, cfg

    lprd   (r2,r1), intbase


	
 #----------------------------------------------------------------------#
 # Here you can enter all the initializations that are specificaly      #
 # appropriate to the environment you are working with. For example :   #
 # 1. Wait States and BIU configuration to get the best performance out #
 #    of your ADB (see the specification document).                     #
 # 2. Maskable Interrupts enabling to enable interrupts at the begining #
 #    of your program.                                                  #

 #----------------------------------------------------------------------#
 # Jump to your main function.                                          #

    bal   (ra), _main

 #----------------------------------------------------------------------#
 # When returnig from the main function (if it wasn't an infinite loop)  #
 # jump to the exit function to exit. The exit function is located in   #
 # "libc".                                                              #

    movw        r0, r2          # main's return value is a parameter for exit.

    br          _exit
 #----------------------------------------------------------------------#
 # Define the eop (End Of Program) function. This function will be      #
 # called by the exit function. At this point it goes into an endless   #
 # loop.                                                                #

__eop::
    br          __eop
