 ########################################################################
 # This is the reset driver for CR16BT                                  #                                 
 ########################################################################
	.text

start::


 #----------------------------------------------------------------------#
 # Initialize the stacks pointers. The constants __STACK_START,         #
 # __ISTACK_START and __STATIC_BASE_START should be defined in the      #
 # linker definition file.                                              #             

    movw    $__STACK_START, sp		# Initialize program stack.
    movw    $__ISTACK_START, r0		# Initialize interrupt stack.
    lpr		r0, isp

    movw	$__STATIC_BASE_START, r13 # Needed only when using 
	                                  # 'sbrel' optimization.         


 #----------------------------------------------------------------------#
 # Initialize sections according to the linker init table.              #
 # You can choose different functions to initialize a different set     #
 # of sections. The functions available in this library are:            #
 # 1. init_bss()                                                        #
 # 2. init_data()                                                       #
 # 3. init_bss_data()                                                   #
 # 4. init_bss_data_code()                                              #

    bal	ra, _init_bss_data	

 #----------------------------------------------------------------------#
 # in order to debug your program, while using your own dispatch table, #
 # you should first get all the  trap handlers into it.                 #
 # For that, you can use TMON service by calling SVC trap with 0x101    #
 # as parameter. TMON will then copy all the addresses of the trap      #
 # handlers routines into your dispatch table, pointed by               #
 # "__dispatch_table" constant variable (the definition of              #
 # __dispatch_table is in intable.c). When moving from developing phase #
 # to product phase, the line "excp svc" should be modified to "nop".   #

    movw 	$__dispatch_table, r1		# Initialize intbase.
 #  movw	$0x101, r0
 #  excp	svc
    lpr 	r1,intbase        
        
 #----------------------------------------------------------------------#
 # Here you can enter all the initializations that are specificaly      #
 # appropriate to the environment you are working with. For example :   #
 # 1. Wait States and BIU configuration to get the best performance out #
 #    of your ADB (see the specification document).                     #
 # 2. Maskable Interrupts enabling to enable interrupts at the begining #
 #    of your program.                                                  #

 #----------------------------------------------------------------------#
 # Jump to your main function.                                          #

    bal    	ra, _main	# C program entry point.

 #----------------------------------------------------------------------#
 # When returnig from the main function (if it wasn't an infinit loop)  #
 # jump to the exit function to exit. The exit function is located in   #
 # "libc".                                                              #

    movw   	r0, r2 		# main's return value is a parameter for exit.

    br     	_exit
 #----------------------------------------------------------------------#
 # Define the eop (End Of Program) function. This function will be      #
 # called by the exit function. It will return control to the debugger. #

__eop::
    br __eop
