
#include "drivers.h"

#include "config.h"
#include "crcommon.h"
#include "chipdef.h"
#include "boarddef.h"
#include "boarddrv.h"
#include "descrpt.h"

#define N_EPS_USED        7
#define USB_BUFFER_SIZE 200

// Select whether to use USB API in asynch mode or not 
// (comment out define for NOT - blocking/synchronous driver API)
#define USE_ASYNCH

uint8 ucBuffer[N_EPS_USED][USB_BUFFER_SIZE];

uint vendor_cnt = 0;
uint last_rx_ep = 0;

uint            usb_evt_cnt [N_EPS_USED];
uint            last_count  [N_EPS_USED];
ep_xfer_stat_t  last_state  [N_EPS_USED];

boolean USBConfigured=FALSE;

void usb_evt_cb( usb_evt_t evt, ep_id_t ep )
{
  switch (evt)
  {
    case USB_EP_EVT:
    {
  		get_ep_stat( ep, &last_state[ep], &last_count[ep] );
  		
  		if (ep) // Not interested in ep0 for this
  		    if (!(ep & 0x01)) // Only RX (even) endpoints important
  			    if ((last_state[ep] == TRNSFRCOMPLETE) && !last_rx_ep)
  		          last_rx_ep = ep;
  		
  		usb_evt_cnt[ep]++;  
      break;
    }
          
	  case USB_SD3_SUSPEND:
    {
	      led_set(0); // Red LED
        break;
    }
	  
    case USB_SD5_SUSPEND:
    {
    		led_set(1); // Green
        break;
    }
    
    case USB_RESUME:
    {
        led_set(2); // Yellow
        break;
    }

	case USB_CONFIGURED:
	{
		USBConfigured=TRUE;
		break;
	}
    
    case USB_WARN_EVT:
    case USB_FRAME_EVT:
        break;
  }
}       

void vendor_cbk(usb_request_t USBRequest)
{
    vendor_cnt++;
}
