/************************************************************************
	File Name : boarddef.h															  

	Function:	This file includes one board header header file according
				to the value of DEV_BOARD symbol.
************************************************************************/
#ifndef BOARDDEF_H
#define BOARDDEF_H

#include "config.h"

#ifndef DEV_BOARD
#  error "DEV_BOARD not defined"
#endif

#define NO_EEPROM 			0
#define ATMEL_24C16 		1
#define MICROCHIP_24LC65 	2

#define NO_EXTUART			0
#define NS16552				1

#define NO_CODEC			0
#define MC145483			1 	// Motorola MC145483 codec
#define MSM7716				2	// OKI MSM7716 codec
#define MSM7732				3	// OKI MSM7732 codec

#define NO_LED				0
#define LED_MEM_MAPPED_RW	1
		// LED implemented with read/write memory mapped register
#define LED_MEM_MAPPED_WO	2	
		// LED implemented with write-only memory mapped register
#define LED_GPIO			3
		// LED implemented with general purpose I/O

#define NO_LED7SEG				0
#define LED7SEG_MEM_MAPPED_RW	1
		// 7-segment LED implemented with read/write memory mapped register
#define LED7SEG_MEM_MAPPED_WO	2
		// 7-segment LED implemented with write-only memory mapped register
#define LED7SEG_GPIO				3
		// 7-segment LED implemented with general purpose I/O


#if (DEV_BOARD == CUSTOM_BOARD)
#  include "custom_board.h"  
#endif

#if (DEV_BOARD == BDB)
#  include "bdb.h"
#endif

#if (DEV_BOARD == CP3BH19_BOARD)
#  include "cp3bh19_board.h"
#endif

#if (DEV_BOARD == CP3DBXX1X)
#  include "cp3dbxx1x.h"
#endif

#if (DEV_BOARD == CP3DBXX26)
#  include "cp3dbxx26.h"
#endif

#endif
