/******************************************************************************
*  File:	config.h
*  
*  This files includes global configuration parameters.
******************************************************************************/

#ifndef CONFIG_H
#define CONFIG_H


/* Definitions of configuration parameter values */

#define CP3BT1X 1
#define CP3BT2X 2

#define DEV_MODE 1
#define REL_MODE 2

#define NVS_EXTERNAL 1
#define NVS_INTERNAL 2

#define CUSTOM_BOARD 0
#define BDB 1
#define CP3BH19_BOARD 2
#define CP3DBXX1X 4
#define CP3DBXX26 5

#define SYS_CLOCK_6MHZ 1
#define SYS_CLOCK_12MHZ 2
#define SYS_CLOCK_18MHZ 3
#define SYS_CLOCK_24MHZ 4
#define SYS_CLOCK_30MHZ 5
#define SYS_CLOCK_36MHZ 6

#define SRC_XTAL 0
#define SRC_RF_CHIP 1

#define LMX5250 1
#define LMX5251 2
#define LMX5252 3

#define MEDIUM 2
#define LARGE 3

#define ISP_PHY_USART 0
#define ISP_PHY_USB 1

#define ISP_USART0 0
#define ISP_USART1 1
#define ISP_USART2 2
#define ISP_USART3 3

#define ISP_USART_9600		0
#define ISP_USART_38400		1
#define ISP_USART_115200	2
#define ISP_USART_230400	3
#define ISP_USART_460800	4
#define ISP_USART_921600	5
#define ISP_USART_AUTOBAUD	100

#define ISP_EXTERNAL_FLASH_NONE 0
#define ISP_EXTERNAL_FLASH_CFI  1
	


#define ISP_NO_FLOW_CONTROL			0
#define ISP_HARDWARE_FLOW_CONTROL	1




/* Definitions of configuration parameters */

#include "settings.h"

/* Definitions derivatives */

//#if (WORK_MODE == DEV_MODE)
//#  define DEBUG
//#endif

#endif
