/************************************************************************
	File Name : cp3dbxx1x.h															  

	Function:	This file includes definitions for the CP3DBXX1X
				Developemnt Board.
************************************************************************/
#include "drivers.h"

#ifndef CP3DBXX1X_H
#define CP3DBXX1X_H


#define EEPROM ATMEL_24C16
#define EXTUART NO_EXTUART
#define CODEC MC145483

/***********************************************************************
 *
 * On-Board register section
 *
 ***********************************************************************/

# define UART_BASE_ADDR (* ((FARIO volatile unsigned char *) 0xfffb40))
# define LEDCTRL (* ((FARIO volatile unsigned char *) 0xfffbb8))


/***********************************************************************
 *
 * LED Display section
 *
 ***********************************************************************/

#define LED_TYPE LED_MEM_MAPPED_WO
#define LED_REG LEDCTRL
#define LED_REG_OFFSET 0
#define LED_MASK 0x00ff
#define LED_POLARITY 1

#define LED7SEG_TYPE NO_LED7SEG
#define LED7SEG_REG LED7SEGCTRL
#define LED7SEG_REG_OFFSET 0
#define LED7SEG_MASK 0x000f
#define LED7SEG_POLARITY 1

/***********************************************************************
 *
 * DIP switch section
 *
 ***********************************************************************/

/* Dip switches 1-4 are connected to GPIO pins PH[0:3] and are logical
   switches 0-3. Jumpers J42-J45 should be connected for the switches
   to be effective.
*/

#define NUM_SWITCHES 4
#define SWITCHREG (gpio_read(PORTH, 0xff))
#define SWITCH0_OFFSET 0
#define SWITCH_POLARITY 0

#endif /* CP3DBXX1X_H */
