/************************************************************************
	File Name : cp3dbxx26.h															  

	Function:	This file includes definitions for the Neptune CP3xx26 
				Developemnt Board low cost version (CP3-DB-xx26).
************************************************************************/

#include "drivers.h"

#ifndef CP3DBXX26_H
#define CP3DBXX26_H

#define EEPROM MICROCHIP_24LC65
#define EXTUART NO_EXTUART

//#define CODEC MC145483
#define CODEC MSM7716

/***********************************************************************
 *
 * On-Board register section
 *
 ***********************************************************************/

# define UART_BASE_ADDR (* ((FARIO volatile unsigned char *) 0xfffb40))
# define LED7SEGCTRL (* ((FARIO volatile unsigned char *) 0xfffb70))
# define LEDCTRL (* ((FARIO volatile unsigned char *) 0xfffb78))

/***********************************************************************
 *
 * LED Display section
 *
 ***********************************************************************/

#define LED_TYPE LED_MEM_MAPPED_WO
#define LED_REG LEDCTRL
#define LED_REG_OFFSET 0
#define LED_MASK 0x00ff
#define LED_POLARITY 1

#define LED7SEG_TYPE NO_LED7SEG
#define LED7SEG_REG LED7SEGCTRL
#define LED7SEG_REG_OFFSET 0
#define LED7SEG_MASK 0x000f
#define LED7SEG_POLARITY 1

/***********************************************************************
 *
 * DIP switch section
 *
 ***********************************************************************/

/* Switches S10 and S12 can be connected to any GPIO (by running jumpers).
   and are logical switches 0-1. We choose GPIO pins PF[0:1].
*/

#define NUM_SWITCHES 2
#define SWITCHREG (gpio_read(PORTF, 0xff))
#define SWITCH0_OFFSET 0
#define SWITCH_POLARITY 0

#endif /* CP3DBXX26_H */
