/************************************************************************
*	File Name:	heap.h
*
*	Function:	This files includes the heap definitions that are necessary
*				for dynamic memory allocation. When using the the IAR
*				CLIB library (as opposed to DLIB library), this is how
*				the heap is defined. For the National Tools this redefines 
*				the 
*				This file should be typically
*				included in the application main source file and not in
*				any other source.
************************************************************************/

#ifndef HEAP_H
#define HEAP_H

#ifdef __IAR_SYSTEMS_ICC__

#include "memstruc.i"


#ifndef HEAP_SIZE
#define HEAP_SIZE 1000
#endif

#ifndef MALLOC_BUFSIZE
#define MALLOC_BUFSIZE HEAP_SIZE
#endif

/* Get number of align buckets from number of bytes */
#define __NR_ELEMENTS__ (__HEAP_SIZE__(MALLOC_BUFSIZE))

/* Allocate the actual heap, */
static MEM_ATTRIBUTE __align_union__ bulk_storage[__NR_ELEMENTS__];

/* a pointer to the first byte */
char PTR_ATTRIBUTE *const _heap_of_memory = (char PTR_ATTRIBUTE *) 
                                            bulk_storage;

/* a pointer to still free heap memory, */
char PTR_ATTRIBUTE *_last_heap_object = (char PTR_ATTRIBUTE *) bulk_storage;

/* and a pointer to last byte in the heap */
char PTR_ATTRIBUTE *const _top_of_heap = (char PTR_ATTRIBUTE *)
                                         (bulk_storage + __NR_ELEMENTS__ - 1);


#endif	/* __IAR_SYSTEMS_ICC__ */


#ifdef __NSC_CRCC__

#ifndef HEAP_SIZE
#define HEAP_SIZE 1000
#endif


char heap_buffer[HEAP_SIZE];					/* Actual heap memory buffer. */
char *end_of_heap = &heap_buffer[HEAP_SIZE];	/* Pointer to last element on 
												   the heap.
												*/


#endif	/* __NSC_CRCC__ */

#endif /* HEAP_H*/



