/*********************************************************************************************
	
	File Name:		vt100.h

	Description:	This file contains the globals and function prototype for the vt100 
					utilities, e.g., Setting the cursor position, setting the text color, etc.
	
	!--Note:		The actual character strings to do all the above have to be defined in 
					the same order as they appear here.

**********************************************************************************************/


#ifndef VT100_H
#define VT100_H

#include <stdio.h>
#include <stdarg.h>

#define SETCURSORPOSITION		0
#define SAVECURSORPOSITION		1
#define RESTORECURSORPOSITION	2
#define SETCURSORHOME			3
#define SETCURSORBACKWARDS		4
#define SETCURSORFORWARD		5
#define ERASELINE				6

#define CLEARWHOLESCREEN		7
#define ENABLELINEWRAP			8
#define ENABLESCROLLSCREEN		9
#define DISABLESCROLLSCREEN		10

#define DISABLEALLATTRIBUTES	11
#define SETTEXTBRIGHT			12
#define RESETTEXTBRIGHT			13
#define SETTEXTDULL				14
#define RESETTEXTDULL			15
#define SETTEXTBLINKING			16
#define RESETTEXTBLINKING		17
#define SETTEXTUNDERSCORE		18
#define RESETTEXTUNDERSCORE		19
#define SETTEXTRED				20
#define SETTEXTGREEN			21
#define SETTEXTBLUE				22
#define SETBACKGROUNDRED		23
#define SETBACKGROUNDGREEN		24
#define SETBACKGROUNDBLUE		25

void VT100Action(int CommandCode, ...);

#endif /* VT100_H */
